## lxd 3.0.3

=== Makefile ===
DOMAIN=lxd
POFILES=$(wildcard po/*.po)
MOFILES=$(patsubst %.po,%.mo,$(POFILES))
LINGUAS=$(basename $(POFILES))
POTFILE=po/$(DOMAIN).pot
VERSION=$(shell grep "var Version" shared/version/flex.go | cut -d'"' -f2)
ARCHIVE=lxd-$(VERSION).tar
TAG_SQLITE3=$(shell printf "\#include <sqlite3.h>\nvoid main(){int n = SQLITE_IOERR_NOT_LEADER;}" | $(CC) ${CGO_CFLAGS} -o /dev/null -xc - >/dev/null 2>&1 && echo "libsqlite3")
GOPATH ?= $(HOME)/go

.PHONY: default
default:
ifeq ($(TAG_SQLITE3),)
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	go get -t -v -d ./...
	CC=$(CC) go install -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	@echo "LXD built successfully"

.PHONY: client
client:
	go get -t -v -d ./...
	go install -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./lxc
	@echo "LXD client built successfully"

.PHONY: lxd-p2c
lxd-p2c:
	CGO_ENABLED=0 go install -v -tags netgo ./lxd-p2c
	@echo "LXD-P2C built successfully"

.PHONY: deps
deps:
	# sqlite
	@if [ -d "$(GOPATH)/deps/sqlite" ]; then \
		cd "$(GOPATH)/deps/sqlite"; \
		git pull; \
	else \
		git clone --depth=1 "https://github.com/CanonicalLtd/sqlite" "$(GOPATH)/deps/sqlite"; \
	fi

	cd "$(GOPATH)/deps/sqlite" && \
		./configure --enable-replication --disable-amalgamation --disable-tcl && \
		git log -1 --format="format:%ci%n" | sed -e 's/ [-+].*$$//;s/ /T/;s/^/D /' > manifest && \
		git log -1 --format="format:%H" > manifest.uuid && \
		make

	# dqlite
	@if [ -d "$(GOPATH)/deps/dqlite" ]; then \
		cd "$(GOPATH)/deps/dqlite"; \
		git pull; \
	else \
		git clone --depth=1 "https://github.com/CanonicalLtd/dqlite" "$(GOPATH)/deps/dqlite"; \
	fi

	cd "$(GOPATH)/deps/dqlite" && \
		autoreconf -i && \
		PKG_CONFIG_PATH="$(GOPATH)/deps/sqlite/" ./configure && \
		make CFLAGS="-I$(GOPATH)/deps/sqlite/" LDFLAGS="-L$(GOPATH)/deps/sqlite/.libs/"

	# environment
	@echo ""
	@echo "Please set the following in your environment (possibly ~/.bashrc)"
	@echo "export CGO_CFLAGS=\"-I$(GOPATH)/deps/sqlite/ -I$(GOPATH)/deps/dqlite/include/\""
	@echo "export CGO_LDFLAGS=\"-L$(GOPATH)/deps/sqlite/.libs/ -L$(GOPATH)/deps/dqlite/.libs/\""
	@echo "export LD_LIBRARY_PATH=\"$(GOPATH)/deps/sqlite/.libs/:$(GOPATH)/deps/dqlite/.libs/\""

.PHONY: update
update:
	go get -t -v -d -u ./...
	@echo "Dependencies updated"

.PHONY: update-protobuf
update-protobuf:
	protoc --go_out=. ./lxd/migration/migrate.proto

.PHONY: update-schema
update-schema:
	go run -v -tags "$(TAG_SQLITE3)" ./lxd/schema.go
	@echo "Schema source code updated"

.PHONY: debug
debug:
ifeq ($(TAG_SQLITE3),)
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	go get -t -v -d ./...
	CC=$(CC) go install -v -tags "$(TAG_SQLITE3) logdebug" $(DEBUG) ./...
	@echo "LXD built successfully"

.PHONY: check
check: default
	go get -v -x github.com/rogpeppe/godeps
	go get -v -x github.com/remyoudompheng/go-misc/deadcode
	go get -v -x github.com/golang/lint/golint
	go test -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	cd test && ./main.sh

.PHONY: dist
dist:
	# Cleanup
	rm -Rf $(ARCHIVE).gz

	# Create build dir
	$(eval TMP := $(shell mktemp -d))
	git archive --prefix=lxd-$(VERSION)/ HEAD | tar -x -C $(TMP)
	mkdir -p $(TMP)/dist/src/github.com/lxc
	ln -s ../../../../lxd-$(VERSION) $(TMP)/dist/src/github.com/lxc/lxd

	# Download dependencies
	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...

	# Download the cluster-enabled sqlite/dqlite
	git clone --depth=1 https://github.com/CanonicalLtd/dqlite $(TMP)/dist/dqlite
	git clone --depth=1 https://github.com/CanonicalLtd/sqlite $(TMP)/dist/sqlite
	cd $(TMP)/dist/sqlite && git log -1 --format="format:%ci%n" | sed -e 's/ [-+].*$$//;s/ /T/;s/^/D /' > manifest
	cd $(TMP)/dist/sqlite && git log -1 --format="format:%H" > manifest.uuid

	# Write a manifest
	cd $(TMP)/dist && find . -type d -name .git | while read line; do GITDIR=$$(dirname $$line); echo "$${GITDIR}: $$(cd $${GITDIR} && git show-ref HEAD $${GITDIR} | cut -d' ' -f1)"; done | sort > $(TMP)/dist/MANIFEST

	# Assemble tarball
	rm $(TMP)/dist/src/github.com/lxc/lxd
	ln -s ../../../../ $(TMP)/dist/src/github.com/lxc/lxd
	mv $(TMP)/dist $(TMP)/lxd-$(VERSION)/
	tar --exclude-vcs -C $(TMP) -zcf $(ARCHIVE).gz lxd-$(VERSION)/

	# Cleanup
	rm -Rf $(TMP)

.PHONY: i18n update-po update-pot build-mo static-analysis
i18n: update-pot update-po

po/%.mo: po/%.po
	msgfmt --statistics -o $@ $<

po/%.po: po/$(DOMAIN).pot
	msgmerge -U po/$*.po po/$(DOMAIN).pot

update-po:
	for lang in $(LINGUAS); do\
	    msgmerge -U $$lang.po po/$(DOMAIN).pot; \
	    rm -f $$lang.po~; \
	done

update-pot:
	go get -v -x github.com/snapcore/snapd/i18n/xgettext-go/
	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG lxc/*.go lxc/*/*.go

build-mo: $(MOFILES)

static-analysis:
	(cd test;  /bin/sh -x -c ". suites/static_analysis.sh; test_static_analysis")

tags: *.go lxd/*.go shared/*.go lxc/*.go
	find . | grep \.go | grep -v git | grep -v .swp | grep -v vagrant | xargs gotags > tags

=== dist/src/github.com/CanonicalLtd/go-dqlite/Makefile ===
proto:
	protoc --gogofast_out=. internal/protocol/commands.proto

.PHONY: proto

=== dist/src/github.com/gogo/protobuf/Makefile ===
# Protocol Buffers for Go with Gadgets
#
# Copyright (c) 2013, The GoGo Authors. All rights reserved.
# http://github.com/gogo/protobuf
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

GO_VERSION:=$(shell go version)

# Skip known issues from purego tests
# https://github.com/gogo/protobuf/issues/447
# https://github.com/gogo/protobuf/issues/448
SKIPISSUE:="/jsonpb|/test/casttype/|/test/oneof/combos/"

.PHONY: nuke regenerate tests clean install gofmt vet contributors

all: clean install regenerate install tests errcheck vet

buildserverall: clean install regenerate install tests vet js purego

install:
	go install ./proto
	go install ./gogoproto
	go install ./jsonpb
	go install ./protoc-gen-gogo
	go install ./protoc-gen-gofast
	go install ./protoc-gen-gogofast
	go install ./protoc-gen-gogofaster
	go install ./protoc-gen-gogoslick
	go install ./protoc-gen-gostring
	go install ./protoc-min-version
	go install ./protoc-gen-combo
	go install ./gogoreplace

clean:
	go clean ./...

nuke:
	go clean -i ./...

gofmt:
	gofmt -l -s -w .

regenerate:
	make -C protoc-gen-gogo regenerate
	make -C gogoproto regenerate
	make -C proto/test_proto regenerate
	make -C proto/proto3_proto regenerate
	make -C jsonpb/jsonpb_test_proto regenerate
	make -C conformance regenerate
	make -C protobuf regenerate
	make -C test regenerate
	make -C test/example regenerate
	make -C test/unrecognized regenerate
	make -C test/group regenerate
	make -C test/unrecognizedgroup regenerate
	make -C test/enumstringer regenerate
	make -C test/unmarshalmerge regenerate
	make -C test/moredefaults regenerate
	make -C test/issue8 regenerate
	make -C test/enumprefix regenerate
	make -C test/enumcustomname regenerate
	make -C test/packed regenerate
	make -C test/protosize regenerate
	make -C test/tags regenerate
	make -C test/oneof regenerate
	make -C test/oneof3 regenerate
	make -C test/theproto3 regenerate
	make -C test/mapdefaults regenerate
	make -C test/mapsproto2 regenerate
	make -C test/issue42order regenerate
	make -C proto generate-test-pbs
	make -C test/importdedup regenerate
	make -C test/importduplicate regenerate
	make -C test/custombytesnonstruct regenerate
	make -C test/required regenerate
	make -C test/casttype regenerate
	make -C test/castvalue regenerate
	make -C vanity/test regenerate
	make -C test/sizeunderscore regenerate
	make -C test/issue34 regenerate
	make -C test/empty-issue70 regenerate
	make -C test/indeximport-issue72 regenerate
	make -C test/fuzztests regenerate
	make -C test/oneofembed regenerate
	make -C test/asymetric-issue125 regenerate
	make -C test/filedotname regenerate
	make -C test/nopackage regenerate
	make -C test/types regenerate
	make -C test/proto3extension regenerate
	make -C test/stdtypes regenerate
	make -C test/data regenerate
	make -C test/typedecl regenerate
	make -C test/issue260 regenerate
	make -C test/issue261 regenerate
	make -C test/issue262 regenerate
	make -C test/issue312 regenerate
	make -C test/enumdecl regenerate
	make -C test/typedecl_all regenerate
	make -C test/enumdecl_all regenerate
	make -C test/int64support regenerate
	make -C test/issue322 regenerate
	make -C test/issue330 regenerate
	make -C test/importcustom-issue389 regenerate
	make -C test/merge regenerate
	make -C test/cachedsize regenerate
	make -C test/deterministic regenerate
	make -C test/issue438 regenerate
	make -C test/issue444 regenerate
	make -C test/issue449 regenerate
	make -C test/xxxfields regenerate
	make -C test/issue435 regenerate
	make -C test/issue411 regenerate

	make gofmt

tests:
	go build ./test/enumprefix
	go test ./...
	(cd test/stdtypes && make test)

vet:
	go vet ./...
	go tool vet --shadow .

errcheck:
	go get github.com/kisielk/errcheck
	errcheck ./test/...

drone:
	sudo apt-get install protobuf-compiler
	(cd $(GOPATH)/src/github.com/gogo/protobuf && make buildserverall)

testall:
	go get -u github.com/golang/protobuf/proto
	make -C protoc-gen-gogo test
	make -C vanity/test test
	make -C test/registration test
	make -C conformance test
	make -C test/issue427 test
	make tests

bench:
	go get golang.org/x/tools/cmd/benchcmp
	(cd test/mixbench && go build .)
	./test/mixbench/mixbench

contributors:
	git log --format='%aN <%aE>' | sort -fu > CONTRIBUTORS

js:
ifeq (go1.11, $(findstring go1.11, $(GO_VERSION)))
	go get -u github.com/gopherjs/gopherjs
	gopherjs build github.com/gogo/protobuf/protoc-gen-gogo
endif

purego:
	go test -tags purego $$(go list ./... | grep -Ev $(SKIPISSUE))

update:
	(cd protobuf && make update)

=== dist/src/github.com/juju/collections/Makefile ===
PROJECT := github.com/juju/collections

.PHONY: check-licence check-go check

check: check-licence check-go
	go test $(PROJECT)/...

check-licence:
	@(fgrep -rl "Licensed under the LGPLv3" .;\
		fgrep -rl "MACHINE GENERATED BY THE COMMAND ABOVE; DO NOT EDIT" .;\
		find . -name "*.go") | sed -e 's,\./,,' | sort | uniq -u | \
		xargs -I {} echo FAIL: licence missed: {}

check-go:
	$(eval GOFMT := $(strip $(shell gofmt -l .| sed -e "s/^/ /g")))
	@(if [ x$(GOFMT) != x"" ]; then \
		echo go fmt is sad: $(GOFMT); \
		exit 1; \
	fi )
	@(go tool vet -all -composites=false -copylocks=false .)

=== dist/src/github.com/golang/protobuf/conformance/Makefile ===
# Go support for Protocol Buffers - Google's data interchange format
#
# Copyright 2016 The Go Authors.  All rights reserved.
# https://github.com/golang/protobuf
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

PROTOBUF_ROOT=$(HOME)/src/protobuf

all:
	@echo To run the tests in this directory, acquire the main protobuf
	@echo distribution from:
	@echo
	@echo '   https://github.com/google/protobuf'
	@echo
	@echo Build the test runner with:
	@echo
	@echo '   cd conformance && make conformance-test-runner'
	@echo
	@echo And run the tests in this directory with:
	@echo
	@echo '   make test PROTOBUF_ROOT=<protobuf distribution>'

test:
	./test.sh $(PROTOBUF_ROOT)

=== dist/src/github.com/mattn/go-sqlite3/_example/mod_vtable/Makefile ===
ifeq ($(OS),Windows_NT)
EXE=extension.exe
EXT=sqlite3_mod_vtable.dll
RM=cmd /c del
LIBCURL=-lcurldll
LDFLAG=
else
EXE=extension
EXT=sqlite3_mod_vtable.so
RM=rm
LDFLAG=-fPIC
LIBCURL=-lcurl
endif

all : $(EXE) $(EXT)

$(EXE) : extension.go
	go build $<

$(EXT) : sqlite3_mod_vtable.cc
	g++ $(LDFLAG) -shared -o $@ $< -lsqlite3 $(LIBCURL)

clean :
	@-$(RM) $(EXE) $(EXT)

=== dist/src/golang.org/x/net/http2/h2demo/Makefile ===
# Copyright 2018 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

MUTABLE_VERSION ?= latest
VERSION ?= $(shell git rev-parse --short HEAD)

IMAGE_STAGING := gcr.io/go-dashboard-dev/h2demo
IMAGE_PROD := gcr.io/symbolic-datum-552/h2demo

DOCKER_IMAGE_build0=build0/h2demo:latest
DOCKER_CTR_build0=h2demo-build0

build0: *.go Dockerfile.0
	docker build --force-rm -f Dockerfile.0 --tag=$(DOCKER_IMAGE_build0) ../..

h2demo: build0
	docker create --name $(DOCKER_CTR_build0) $(DOCKER_IMAGE_build0)
	docker cp $(DOCKER_CTR_build0):/go/bin/$@ $@
	docker rm $(DOCKER_CTR_build0)

ca-certificates.crt:
	docker create --name $(DOCKER_CTR_build0) $(DOCKER_IMAGE_build0)
	docker cp $(DOCKER_CTR_build0):/etc/ssl/certs/$@ $@
	docker rm $(DOCKER_CTR_build0)

update-deps:
	go install golang.org/x/build/cmd/gitlock
	gitlock --update=Dockerfile.0 --ignore=golang.org/x/net --tags=h2demo golang.org/x/net/http2/h2demo

docker-prod: Dockerfile h2demo ca-certificates.crt
	docker build --force-rm --tag=$(IMAGE_PROD):$(VERSION) .
	docker tag $(IMAGE_PROD):$(VERSION) $(IMAGE_PROD):$(MUTABLE_VERSION)
docker-staging: Dockerfile h2demo ca-certificates.crt
	docker build --force-rm --tag=$(IMAGE_STAGING):$(VERSION) .
	docker tag $(IMAGE_STAGING):$(VERSION) $(IMAGE_STAGING):$(MUTABLE_VERSION)

push-prod: docker-prod
	gcloud docker -- push $(IMAGE_PROD):$(MUTABLE_VERSION)
	gcloud docker -- push $(IMAGE_PROD):$(VERSION)
push-staging: docker-staging
	gcloud docker -- push $(IMAGE_STAGING):$(MUTABLE_VERSION)
	gcloud docker -- push $(IMAGE_STAGING):$(VERSION)

deploy-prod: push-prod
	kubectl set image deployment/h2demo-deployment h2demo=$(IMAGE_PROD):$(VERSION)
deploy-staging: push-staging
	kubectl set image deployment/h2demo-deployment h2demo=$(IMAGE_STAGING):$(VERSION)

.PHONY: clean
clean:
	$(RM) h2demo
	$(RM) ca-certificates.crt

FORCE:

=== debian/changelog ===
lxd (3.0.3-0ubuntu1~16.04.1) xenial-backports; urgency=medium

  * Backport to Xenial.
  * Build using Go 1.10 backport
  * Bump dependencies to use backports
    - liblxc1 to 3.0.0~
    - lxcfs to 3.0.0~

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 19 Dec 2018 23:30:26 -0500

lxd (3.0.3-0ubuntu1~18.04.1) bionic; urgency=medium

  * New upstream bugfix release (LP: #1804876)
    - doc: add note about ignoring mount options
    - shared/idmap: test fcaps support
    - Add a few missing rows.Close() calls
    - lxd/patches: Profiles are in the cluster db
    - lxd/storage/ceph: Only freeze container if running
    - lxc: Only target if --target is passed
    - shared: Return decompressor in DetectCompression
    - lxd/containers: Don't return nil on Storage calls
    - tests: Fix mode of proxy.sh
    - shared/api: Don't re-define fields
    - lxd/storage/btrfs: Fix clearing quotas
    - lxd/containers: Also use apply_quota for CEPH
    - lxd/containers: Simplify and fix pool update logic
    - Add NodeIsOutdated() db API to check is a node is outdated
    - Trigger whatever is in the LXD_CLUSTER_UPDATE var is node is outdated
    - lxd/images: Add missing cleanup code
    - lxd/containers: Fix bad function name
    - tests: Avoid err == nil pattern
    - lxd: Don't mask database errors
    - Honor the CC environment variable when invoking go install
    - client: Avoid err == nil pattern
    - lxd/profiles: Don't list snapshots in UsedBy
    - Make database queries timeout after 10s if cluster db is unavail
    - tests: Fix pki with newer easyrsa
    - lxd/db: Fix internal DB test
    - doc: Fix and improve the description
    - operations: return true if operation is done before timeout
    - lxd/containers: Avoid root device name conflict
    - lxd/import: Add root disk if needed
    - global: Advertise rsync features
    - lxd/db: Use NoSuchObject consistently
    - proxy: Only log errors
    - lxd/import: Don't delete container on import failure
    - i18n: Update translation templates
    - Support --domain flag for lxc remote
    - Add configurable macaroon expiry
    - Support Candid domain validation
    - Update Candid docs
    - Update i18n
    - lxd: Rename API endpoints
    - network_linux: add netns_getifaddrs()
    - main_checkfeature: check kernel for netnsid support
    - network: add NetworkGetCounters()
    - container_lxc: switch to NetnsGetifaddrs()
    - shared: Add network state API
    - api: Add extended cluster join API
    - lxd/init: Fix struct conflict
    - lxc: Identify snapshots when listed
    - shared/version: Support detecting ChromeOS versions
    - lxd/containers: Force bring up of SRIOV parent
    - netns_getifaddrs: fix argument passing
    - netnsid_getifaddrs: fix check for netnsid support
    - doc: Fix storage API endpoints
    - container_lxc: handle network retrieval smarter
    - shared: Add storage volume snapshot support
    - client: Add storage volume snapshot support
    - netns_getifaddrs: don't print useless info
    - shared/api: Fix StorageVolumeSource struct
    - Makefile: Set LDFLAGS for dqlite
    - lxd: Fix handling of CGroup-V2 systems
    - tree-wide: pass -std=gnu11 -Wvla
    - lxd/containers: Rework exec FD handling
    - Added optional ?target=<member> to /containers POST documentation
    - lxd/storage/lvm: Don't un-necessarily start/stop storage
    - lxd/storage/ceph: Don't un-necessarily mount snapshots
    - lxd/containers: Fix cleanup on create failure
    - shared/network: Don't crash on VPN devices
    - lxd/containers: Fix bad nvidia information parsing
    - netns_getifaddrs: fix network stats retrieval
    - network: Fix counters on non-ethernet interfaces
    - doc: Add configuration for readthedocs
    - storage: Fix error strings
    - lxd/storage/btrfs: Don't fail deleting pools on misisng disk
    - Split code in 2 seperate files
    - network: provide #ifdefs for RTM_* requests
    - Document LVM support for storage quotas
    - candid: Cleanup code a bit
    - network: fix netns_get_nsid() signature
    - apparmor: Allow cgroupv2 in cgns
    - candid: Fix client when using https candid server
    - lxd-p2c: Fix static build
    - config: Add support for PEM encrypted keys
    - lxc: Setup password helper
    - lxc/config: Only setup needed connection args
    - lxc/config: More TLS optimizations
    - i18n: Update translation templates
    - macro: add SOL_NETLINK
    - macro: add NETLINK_DUMP_STRICT_CHK
    - netns_ifaddrs: check for NETLINK_DUMP_STRICT_CHK
    - Fix Potential Event Race
    - devices: Fix bad disk limits
    - Fix root disk limits on container startup
    - checkfeature: Rework structure
    - checkfeature: simplify is_netnsid_aware() check
    - checkfeature: Avoid double line break
    - checkfeature: dial logging down from to debug
    - lxc/progress: Add terminal detection
    - doc: Rework backup documentation
    - client: Add GetNetworkState
    - client: Add extended cluster join API
    - client: Add UseProject
    - shared/api: Add projects
    - client: Add support for projects
    - lxc/config: Add support for projects
    - Change query.SelectObjects signature to support a prepared statement
    - Add query.SelectURIs convenience for getting API resource URIs
    - Add cluster statements registry
    - api: Add Project.Config reference
    - Improve some error messages around container creation
    - Lookup for the "target" API parameter only in the URL query string
    - Automatically add ?project=x query param to image server
    - Improve error reporting when creating a container
    - Change ContainerStorageRead() to take a container object
    - Improve error messages around LVM volume creation
    - Change Storage.ContainerUmount to accept a container vs a container name
    - lxd/init: Update for current client package
    - lxc/progress: Don't print empty lines
    - candid: Improve domain validation and pubkey
    - lxd/images: Fix parsing of public property


=== debian/control ===
Source: lxd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 4.2.1
Homepage: https://linuxcontainers.org/
Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
Build-Depends: debhelper (>= 10),
               dh-apparmor,
               dh-golang,
               golang-1.10-go,
               help2man,
               libacl1-dev,
               libcap-dev,
               libuv1-dev,
               lxc-dev (>= 1.1.0~),
               pkg-config,
               python3-lxc,
               tcl8.6-dev
XS-Go-Import-Path: github.com/lxc/lxd

Package: lxd-client
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Suggests: lxd
Breaks: lxc1 (<= 2.0.0~rc13-0ubuntu2~)
Replaces: lxc1 (<= 2.0.0~rc13-0ubuntu2~)
Description: Container hypervisor based on LXC - client
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the command line client.

Package: lxd
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: acl,
         adduser,
         dnsmasq-base,
         ebtables,
         iproute2,
         iptables,
         liblxc1 (>= 3.0.0~),
         lsb-base (>= 3.0-6),
         lxcfs (>= 3.0.0~),
         lxd-client (= ${binary:Version}),
         passwd (>= 1:4.1.5.1-1ubuntu5~),
         rsync,
         squashfs-tools,
         uidmap (>= 1:4.1.5.1-1ubuntu5~),
         xdelta3,
         xz-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Recommends: apparmor
Suggests: criu, lxd-tools
Description: Container hypervisor based on LXC - daemon
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the LXD daemon.

Package: lxd-tools
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: python3, python3-lxc, ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Container hypervisor based on LXC - extra tools
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains extra tools provided with LXD.
  - fuidshift - A tool to map/unmap filesystem uids/gids
  - lxc-to-lxd - A tool to migrate LXC containers to LXD
  - lxd-benchmark - A benchmarking tool for LXD

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKGDIR=debian/tmp
VERSION=$(shell grep "var Version" $(CURDIR)/shared/version/flex.go | cut -d'"' -f2)
include /usr/share/dpkg/default.mk

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
export DH_GOPKG := github.com/lxc/lxd
export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
export USE_EMBEDDED := true
export USE_SHLIBS := false

# Handled sqlite/dqlite custom libraries
export CGO_LDFLAGS=-L$(CURDIR)/dist/sqlite/.libs/ -L$(CURDIR)/dist/dqlite/.libs/
export CGO_CFLAGS=-I$(CURDIR)/dist/sqlite/ -I$(CURDIR)/dist/dqlite/include/

# use golang-1.10
export PATH := /usr/lib/go-1.10/bin:$(PATH)

ifeq ($(USE_SHLIBS), true)
export DH_GOLANG_LINK_SHARED := 1
endif

%:
	dh $@ --with systemd --buildsystem=golang --with=golang

override_dh_auto_build:
	# Build our own sqlite3
	cd dist/sqlite && \
		./configure --enable-replication --disable-amalgation --disable-tcl && \
		make

	# And build dqlite
	cd dist/dqlite && \
		autoreconf -i && \
		PKG_CONFIG_PATH="$(CURDIR)/dist/sqlite/" ./configure && \
		sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool && \
		sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool && \
		make CFLAGS="-I$(CURDIR)/dist/sqlite/" LDFLAGS="-L$(CURDIR)/dist/sqlite/.libs"

	# And then build using it
	dh_auto_build -- -tags libsqlite3

# Ugly workaround for bundled dependencies
override_dh_auto_configure:
	dh_auto_configure

	# dh-golang's configure has copied the source tree into GOPATH. But
	# because lxd gets some dependencies from the archive and some from
	# the copies bundled in dist, we have to unpick a bunch of what it has
	# done and set it up again.

	# Remove the extra copy of dist dh-golang has copied onto GOPATH (or
	# when dh-golang tries to run go install github.com/lxc/lxd/... things
	# get very confused).
	rm -Rf ${GOPATH}/src/github.com/lxc/lxd/dist

	# Move the lxd source aside while we do this.
	mv ${GOPATH}/src/github.com/lxc/lxd ${GOPATH}/lxd.tmp

	# Clean GOPATH.
ifeq ($(USE_SHLIBS), true)
	rm -Rf ${GOPATH}/src/srclibs
else
	rm -Rf ${GOPATH}/src
endif

ifeq ($(USE_EMBEDDED), true)
	# If we get all dependencies from dist, just copy it onto GOPATH.
	cp -R dist/src ${GOPATH}

	# But not the symlink for lxd.
	rm -f ${GOPATH}/src/github.com/lxc/lxd
else
	# If not, link depedencies from dist or from where the distro package
	# has installed it, as appropriate.

	# Packaged dependencies
	debian/helpers/link-from-installed github.com/dustinkirkland/golang-petname
	debian/helpers/link-from-installed github.com/golang/protobuf
	debian/helpers/link-from-installed github.com/gorilla/context
	debian/helpers/link-from-installed github.com/gorilla/mux
	debian/helpers/link-from-installed github.com/gorilla/websocket
	debian/helpers/link-from-installed github.com/gosexy/gettext
	debian/helpers/link-from-installed github.com/mattn/go-colorable
	debian/helpers/link-from-installed github.com/mattn/go-sqlite3
	debian/helpers/link-from-installed github.com/olekukonko/tablewriter
	debian/helpers/link-from-installed github.com/pborman/uuid
	debian/helpers/link-from-installed github.com/syndtr/gocapability
	debian/helpers/link-from-installed golang.org/x/crypto
	debian/helpers/link-from-installed gopkg.in/flosch/pongo2.v3
	debian/helpers/link-from-installed gopkg.in/inconshreveable/log15.v2
	debian/helpers/link-from-installed gopkg.in/lxc/go-lxc.v2
	debian/helpers/link-from-installed gopkg.in/tomb.v2
	debian/helpers/link-from-installed gopkg.in/yaml.v2
endif

	# And put the lxd source back again.
	mkdir -p ${GOPATH}/src/github.com/lxc/
	mv ${GOPATH}/lxd.tmp ${GOPATH}/src/github.com/lxc/lxd

override_dh_install:
	# Install lxc-to-lxd
	cp scripts/lxc-to-lxd $(PKGDIR)/usr/bin/lxc-to-lxd

	# Install the manpages
	mkdir -p $(PKGDIR)/usr/share/man/man1/
	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
	help2man $(PKGDIR)/usr/bin/lxc-to-lxd -n "Convert LXC containers to LXD" --no-info --version-string=$(VERSION) > $(PKGDIR)/usr/share/man/man1/lxc-to-lxd.1
	help2man $(PKGDIR)/usr/bin/lxd-benchmark -n "The container lightervisor - benchmark" --no-info --no-discard-stderr > $(PKGDIR)/usr/share/man/man1/lxd-benchmark.1
	LD_LIBRARY_PATH=$(PKGDIR)/dist/sqlite/.libs/:$(CURDIR)/dist/dqlite/.libs/:${LD_LIBRARY_PATH} $(PKGDIR)/usr/bin/lxd manpage $(PKGDIR)/usr/share/man/man1/
	$(PKGDIR)/usr/bin/lxc manpage $(PKGDIR)/usr/share/man/man1/

	# Install bash completion scripts
	mkdir -p $(PKGDIR)/usr/share/bash-completion/completions/
	cp scripts/bash/lxd-client $(PKGDIR)/usr/share/bash-completion/completions/lxc

	# Prepare dev package
	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	mkdir -p $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	cp -RL ${GOPATH}/src/github.com/lxc/lxd $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/lxd/dist

	# Copy dnsmasq configuration
	mkdir -p $(PKGDIR)/etc/dnsmasq.d-available
	cp debian/lxd.dnsmasq $(PKGDIR)/etc/dnsmasq.d-available/lxd

	# Setup logrotate
	mkdir -p $(PKGDIR)/etc/logrotate.d
	cp debian/lxd.logrotate $(PKGDIR)/etc/logrotate.d/lxd

	# Setup sysctl
	mkdir -p $(PKGDIR)/etc/sysctl.d
	cp debian/lxd.sysctl $(PKGDIR)/etc/sysctl.d/10-lxd-inotify.conf

	# Include wrappers, sqlite3 and dqlite libraries
	mkdir -p $(PKGDIR)/usr/lib/lxd/
	mv $(PKGDIR)/usr/bin/lxd $(PKGDIR)/usr/lib/lxd/
	cp debian/wrappers/lxd $(PKGDIR)/usr/bin/
	cp debian/wrappers/shutdown $(PKGDIR)/usr/lib/lxd/
	cp debian/wrappers/upgrade-bridge $(PKGDIR)/usr/lib/lxd/
	cp dist/sqlite/.libs/libsqlite3.so.0* $(PKGDIR)/usr/lib/lxd/
	cp dist/dqlite/.libs/libdqlite.so.0* $(PKGDIR)/usr/lib/lxd/

	# Trigger normal dh_install
	dh_install

override_dh_shlibdeps:
	LD_LIBRARY_PATH=$(PKGDIR)/usr/lib/lxd/:${LD_LIBRARY_PATH} dh_shlibdeps -v

override_dh_installinit:
ifeq (,$(findstring $(DEB_DISTRIBUTION), trusty xenial zesty))
	# Disable upstart integration on artful+
	rm -f debian/lxd.upstart
	cp debian/lxd.maintscript.in debian/lxd.maintscript
else
	# Enable upstart integration for backports
	cp debian/lxd.upstart.in debian/lxd.upstart
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd.upstart
	grep -v /etc/init debian/lxd.maintscript.in > debian/lxd.maintscript
endif
	# We handle starting and restarting things ourselves
	dh_systemd_enable -plxd --name=lxd-containers lxd-containers.service
	dh_installinit -plxd --no-start
	dh_installinit -plxd --name=lxd-containers --no-start --noscripts
	dh_systemd_start -plxd lxd-containers.service --no-restart-on-upgrade --no-restart-after-upgrade

	# Update arch-specific paths
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/lib/systemd/system/lxd.service
	sed -i "s#@LIBEXECDIR@#/usr/lib/${DEB_HOST_MULTIARCH}#g" debian/lxd/etc/init.d/lxd

override_dh_systemd_start:
	echo "Not running dh_systemd_start"

override_dh_auto_test:
	echo "The testsuite requires privileges and so is run through autopkgtest"

=== debian/tests/control ===
Tests: exercise
Depends: acl,
         busybox-static,
         btrfs-tools,
         curl,
         golang-go,
         jq,
         git,
         make,
         socat,
         sqlite3,
         thin-provisioning-tools,
         uuid-runtime,
         zfsutils-linux [amd64 arm64 ppc64el s390x],
         @builddeps@,
         @
Restrictions: needs-root allow-stderr isolation-machine

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ https://linuxcontainers.org/lxd/downloads/ /downloads/lxd/lxd-(.*)\.tar\.gz
